﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.8
@EndOfDesignText@
'Code module - modFestitiva

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private mAltreFeste() As String
End Sub

'Format: "L" for Long date or a null string ("")
Public Sub GetEasterSunday(Year As Long, Format As String) As String

	Private C, I, J, H, G, L As Int
	Private D, M As Long
	Private Month() As String
 
	Month = Array As String("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December")

	G = Year Mod 19
	C = Year/100
	H = ((C - (C / 4) - (8 * C + 13) / 25) + 19 * G + 15) Mod 30
	I = H - (H / 28) * (1 - (H / 28) * (29 / (H + 1))*((21 - G) / 11))
	J = (Year + (Year / 4) + I + 2 - C + (C / 4)) Mod 7
	L = I - J
	M = 3 + ((L + 40) / 44)
	D = L + 28 - 31 * Floor(M / 4)

	If Format.ToUpperCase = "L" Then
                
		Return (Month(M - 1) & " " & D & ", " & Year)
                            
	Else
                
		Return (M & "-" & D & "-" & Year)
                            
	End If

End Sub

' AltreFeste può servire per festività locali; ad esempio
' festa del patrono della città:
' 29 giugno (patroni di Roma),
' passare: Array As String("29-6").
Public Sub AltreFeste(Feste() As String)
	mAltreFeste = Feste
End Sub

' Passare: la data in formato gg-MM-aaaa.
Public Sub isFestivo(Data As String) As Boolean
	Dim Festivo As Boolean

	Dim PrevDateFormat As String = DateTime.DateFormat
	DateTime.DateFormat = "dd-MM-yyyy"

	Dim GiornoData, MeseData, AnnoData As Int
	Dim DataTicks As Long
	DataTicks = DateTime.DateParse(Data)
	AnnoData = DateTime.GetYear(DataTicks)
	GiornoData = DateTime.GetDayOfMonth(DataTicks)
	MeseData = DateTime.GetMonth(DataTicks)
	
	Dim Domenica As Boolean
	Domenica = (DateTime.GetDayOfWeek(DataTicks) = 1)
	
	Dim DataPasqua As String
	Dim GiornoPasqua, MesePasqua As Int
	Dim PasquaTicks As Long
	DateTime.DateFormat = "MM-dd-yyyy"
	DataPasqua = GetEasterSunday(AnnoData, "")
	PasquaTicks = DateTime.DateParse(DataPasqua)
	GiornoPasqua = DateTime.GetDayOfMonth(PasquaTicks)
	MesePasqua = DateTime.GetMonth(PasquaTicks)
	
	Dim GiornoPasquetta, MesePasquetta As Int
	Dim PasquettaTicks As Long
	PasquettaTicks = DateTime.Add(PasquaTicks, 0, 0, 1)
	GiornoPasquetta = DateTime.GetDayOfMonth(PasquettaTicks)
	MesePasquetta = DateTime.GetMonth(PasquettaTicks)
	
	Dim lstFestivi As List
	lstFestivi.Initialize
	Dim GiornoMesePasqua As String = GiornoPasqua & "-" & MesePasqua
	Dim GiornoMesePasquetta As String = GiornoPasquetta & "-" & MesePasquetta
	lstFestivi.AddAll(Array As String("1-1", "6-1", "25-04", "1-5", "2-6", "15-8", "1-11", "8-12", "25-12", "26-12", GiornoMesePasqua, GiornoMesePasquetta))
	
	If mAltreFeste <> Null Then
		lstFestivi.AddAll(mAltreFeste)
	End If
	
	Dim GiornoMeseData As String
	GiornoMeseData = GiornoData & "-" & MeseData

	Festivo = (lstFestivi.IndexOf(GiornoMeseData) > - 1) Or Domenica
	DateTime.DateFormat = PrevDateFormat
	Return Festivo
End Sub

Public Sub GiorniDelMese(Anno As Int, Mese As Int, Lavorativi As Boolean) As List
	Dim lstGiorniDelMese As List
	lstGiorniDelMese.Initialize

	Dim PrevDateFormat As String = DateTime.DateFormat
	DateTime.DateFormat = "dd-MM-yyyy"

	Dim GiorniMese As Int
	GiorniMese = DateUtils.NumberOfDaysInMonth(Mese, Anno)
	
	Dim Festivo As Boolean

	Dim Ticks As Long
	Dim Data As String
	Data = "01-" & Mese & "-" & Anno
	Ticks = DateTime.DateParse(Data)
	For i = 0 To GiorniMese - 1
		Data = DateTime.Date(DateTime.Add(Ticks, 0, 0, i))
		Festivo = isFestivo(Data)
		If (Lavorativi And Not(Festivo)) Or (Not(Lavorativi) And Festivo) Then
			lstGiorniDelMese.Add(Data)
		End If
	Next
	
	DateTime.DateFormat = PrevDateFormat
	Return lstGiorniDelMese
End Sub

